use std::{any::Any, fs::File, io::{BufWriter, Write}};
use anyhow::Result;
use bfox_parser::types::token::Token;
use bfox_parser::types::token::TokenType;

use crate::AsmGen;


pub fn compile_x86_64_nasm(_asm_gen: &mut AsmGen, tokens: Vec<Token>, bw: &mut BufWriter<File>) -> Result<()>{

    writeln!(bw, "BITS 64")?;

    writeln!(bw, "section .bss")?;
    writeln!(bw, "    memory: resb 30000")?;
    writeln!(bw, "    mem_ptr: resq 1")?;

    // writeln!(bw, "section .data")?;
    // writeln!(bw, "    input db 0")?;
    
    writeln!(bw, "section .text")?;
    writeln!(bw, "_start:")?;

    for t in tokens {
        match t.typ {

            TokenType::Add => {
                writeln!(bw, "    mov rax, memory")?;
                writeln!(bw, "    add rax, [mem_ptr]")?;
                writeln!(bw, "    inc byte [rax]")?;
            }

            ut => todo!("{ut:?}")

        }
    }

    // Exit
    writeln!(bw, "    mov rax, 60")?;
    writeln!(bw, "    mov rdi, 0")?;
    writeln!(bw, "    syscall")?;

    Ok(())
}